//+------------------------------------------------------------------+
//|                                                     ATR Pips.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Joshua Jones"
#property link      "http://www.forexfactory.com"

#property indicator_separate_window
#property indicator_buffers 1

//---- input parameters

extern int periods = 13;
extern double multiplier = 0.7;

extern int TextShift_Side    =0;
extern int TextShift_UP_DN   = 0;
extern color TextColor       = White;
extern int TextSize          = 9;
extern string TextFont       = "Tahoma";
extern int TextCorner        = 0;

int pipMult = 10000;


double buffer[];

string prefix = "";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   if (StringFind(Symbol(),"JPY",0) != -1)
   {
      pipMult = 100;
   }

   if (multiplier != 1.0)
   {
      int percentage = multiplier*100;
      prefix = percentage + "% of ";
   }

   
   SetIndexBuffer(0,buffer);
   SetIndexLabel(0,"ATR (" + periods + ")");
   SetIndexStyle(0,DRAW_LINE);
   IndicatorShortName(prefix + "ATR (" + periods + ")");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   ObjectDelete("ATR_LEVEL");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
   int limit;  
   int counted_bars=IndicatorCounted(); 
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars;


      for (int i = 0; i < limit; i++){
         double stopLoss = MathCeil(pipMult * multiplier * (iATR(NULL,0,periods,i)));
         buffer[i] = stopLoss;
      }
      
                          ObjectDelete("ATR_LEVEL");
               ObjectCreate("ATR_LEVEL", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("ATR_LEVEL",""+prefix+ "ATR ("+ periods+ "): "+DoubleToStr(buffer[0],Digits-4)+"  pips", TextSize,TextFont,TextColor);
   ObjectSet("ATR_LEVEL", OBJPROP_CORNER, TextCorner);
   ObjectSet("ATR_LEVEL", OBJPROP_XDISTANCE, 10+TextShift_Side);
   ObjectSet("ATR_LEVEL", OBJPROP_YDISTANCE, 10+TextShift_UP_DN);
    
   //   Comment(prefix, "ATR (", periods, "): ", buffer[0], " pips");
      
      return(0);
  }
//+------------------------------------------------------------------+